"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const stream_1 = require("stream");
const messages_1 = require("@cucumber/messages");
/**
 * Transforms a stream of message objects to binary
 */
class MessageToBinaryStream extends stream_1.Transform {
    constructor() {
        super({ writableObjectMode: true, readableObjectMode: false });
    }
    _transform(message, encoding, callback) {
        const chunk = messages_1.messages.Envelope.encodeDelimited(message).finish();
        this.push(chunk);
        callback();
    }
}
exports.default = MessageToBinaryStream;
//# sourceMappingURL=MessageToBinaryStream.js.map