"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const stream_1 = require("stream");
/**
 * Transforms a stream of message objects to NDJSON
 */
class MessageToNdjsonStream extends stream_1.Transform {
    constructor() {
        super({ writableObjectMode: true, readableObjectMode: false });
    }
    _transform(message, encoding, callback) {
        const object = message.toJSON();
        // This reviver omits printing fields with empty values
        // This is to make it behave the same as Golang's protobuf->JSON converter
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        const json = JSON.stringify(object, (key, value) => {
            return value === '' ? undefined : value;
        });
        this.push(json + '\n');
        callback();
    }
}
exports.default = MessageToNdjsonStream;
//# sourceMappingURL=MessageToNdjsonStream.js.map